from uuid import UUID

from db.repositories import StatusRepository
from .schemas import StatusSchema


class StatusService:
    status_repository = StatusRepository()

    async def get_status_list(self, **kwargs):
        statuses = await self.status_repository.get_list(**kwargs)
        return [StatusSchema.model_validate(status) for status in statuses]

    async def get_status(self, id: UUID):
        status = await self.status_repository.get(id)
        return StatusSchema.model_validate(status)

    async def create_status(self, **kwargs):
        status = await self.status_repository.create(**kwargs)
        return StatusSchema.model_validate(status)

    async def update_status(self, id: UUID, **kwargs):
        status = await self.status_repository.update(id, **kwargs)
        return StatusSchema.model_validate(status)

    async def delete_status(self, id: UUID):
        return await self.status_repository.delete(id)
